//----------------------------------------------------------------------------------
//		mm_srv NCAg(YC48) vOC  for AviUtl ver0.98ȍ~
//----------------------------------------------------------------------------------
#include	<windows.h>

#include	"input.h"
#include	"mm_srv.h"

//---------------------------------------------------------------------
//		̓vOC\̒`
//---------------------------------------------------------------------
INPUT_PLUGIN_TABLE input_plugin_table = {
	INPUT_PLUGIN_FLAG_VIDEO,							//	tO
														//	INPUT_PLUGIN_FLAG_VIDEO	: 摜T|[g
														//	INPUT_PLUGIN_FLAG_AUDIO	: T|[g
	"mm_srv client (YC48)",									//	vOC̖O
	"AVUFile (*.avu)\0*.avu\0",							//	̓t@CtB^
	"mm_srv client (YC48) version 0.5 By N099",				//	vOC̏
	NULL,//func_init,									//	DLLJnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,//func_exit,									//	DLLIɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	func_open,											//	̓t@CI[v֐ւ̃|C^
	func_close,											//	̓t@CN[Y֐ւ̃|C^
	func_info_get,										//	̓t@C̏擾֐ւ̃|C^
	func_read_video,									//	摜f[^ǂݍފ֐ւ̃|C^
	func_read_audio,									//	f[^ǂݍފ֐ւ̃|C^
	NULL,//func_is_keyframe,							//	L[t[ׂ֐ւ̃|C^ (NULLȂSăL[t[)
	NULL,//func_config,									//	͐ݒ̃_CAOvꂽɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
};


//---------------------------------------------------------------------
//		̓vOC\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C INPUT_PLUGIN_TABLE __declspec(dllexport) * __stdcall GetInputPluginTable( void )
{
	return &input_plugin_table;
}

//---------------------------------------------------------------------
//		t@CI[v
//---------------------------------------------------------------------
INPUT_HANDLE func_open( LPSTR file )
{
	mm_srv_handle *h;

	//YC48̂
	h = open_mm_srv(file, MM_FMT_YC48, 0);

	return (INPUT_HANDLE)h;
}


//---------------------------------------------------------------------
//		t@CN[Y
//---------------------------------------------------------------------
BOOL func_close( INPUT_HANDLE ih )
{
	close_mm_srv((mm_srv_handle *)ih);

	return TRUE;
}


//---------------------------------------------------------------------
//		t@C̏
//---------------------------------------------------------------------
BOOL func_info_get( INPUT_HANDLE ih,INPUT_INFO *iip )
{
	mm_srv_handle *h = (mm_srv_handle *)ih;
	static BITMAPINFOHEADER bmi;

	bmi.biSize = sizeof(BITMAPINFOHEADER);
	bmi.biWidth = h->w;
	bmi.biHeight = h->h;
	bmi.biPlanes = 1;
	bmi.biBitCount = 48;
	bmi.biCompression = '84CY';
	bmi.biSizeImage = h->h * h->pitch;
	bmi.biXPelsPerMeter = bmi.biYPelsPerMeter = 0;
	bmi.biClrUsed = bmi.biClrImportant = 0;

	ZeroMemory(iip, sizeof(INPUT_INFO));

	iip->flag = INPUT_INFO_FLAG_VIDEO;
	iip->rate = h->rate;
	iip->scale = h->scale;
	iip->n = h->frame;
	iip->format = &bmi;
	iip->format_size = sizeof(bmi);
	iip->handler = '84CY';

	return TRUE;
}


//---------------------------------------------------------------------
//		摜ǂݍ
//---------------------------------------------------------------------
int func_read_video( INPUT_HANDLE ih,int frame,void *buf )
{
	mm_srv_handle *h = (mm_srv_handle *)ih;
	BYTE *img;
	SIZE_T size = h->h * h->pitch;

	img = (BYTE*)get_frame_mm_srv(h, frame);
	if(NULL == img){
		size = 0;
	}else{
		CopyMemory(buf, img, size);
	}

	return (int)size;
}

//---------------------------------------------------------------------
//		ǂݍ
//---------------------------------------------------------------------
int func_read_audio( INPUT_HANDLE ih,int start,int length,void *buf )
{
	return 0;
}

