//----------------------------------------------------------------------------------
//		mm_srv NCAg(YUY2) vOC  for AviUtl ver0.98ȍ~
//----------------------------------------------------------------------------------
#include	<windows.h>

#include	"input.h"
#include	"mm_srv.h"

//#define YV12_TEST
#ifdef YV12_TEST
static void yv12_2_yuy2(unsigned char*, unsigned char*, long, long, long);
#endif

//---------------------------------------------------------------------
//		̓vOC\̒`
//---------------------------------------------------------------------
INPUT_PLUGIN_TABLE input_plugin_table = {
	INPUT_PLUGIN_FLAG_VIDEO,							//	tO
														//	INPUT_PLUGIN_FLAG_VIDEO	: 摜T|[g
														//	INPUT_PLUGIN_FLAG_AUDIO	: T|[g
	"mm_srv client (YUY2)",									//	vOC̖O
	"AVUFile (*.avu)\0*.avu\0",							//	̓t@CtB^
	"mm_srv client (YUY2) version 0.5 By N099",				//	vOC̏
	NULL,//func_init,									//	DLLJnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,//func_exit,									//	DLLIɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	func_open,											//	̓t@CI[v֐ւ̃|C^
	func_close,											//	̓t@CN[Y֐ւ̃|C^
	func_info_get,										//	̓t@C̏擾֐ւ̃|C^
	func_read_video,									//	摜f[^ǂݍފ֐ւ̃|C^
	func_read_audio,									//	f[^ǂݍފ֐ւ̃|C^
	NULL,//func_is_keyframe,							//	L[t[ׂ֐ւ̃|C^ (NULLȂSăL[t[)
	NULL,//func_config,									//	͐ݒ̃_CAOvꂽɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
};


//---------------------------------------------------------------------
//		̓vOC\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C INPUT_PLUGIN_TABLE __declspec(dllexport) * __stdcall GetInputPluginTable( void )
{
	return &input_plugin_table;
}

//---------------------------------------------------------------------
//		t@CI[v
//---------------------------------------------------------------------
INPUT_HANDLE func_open( LPSTR file )
{
	mm_srv_handle *h;

#ifdef YV12_TEST
	h = open_mm_srv(file, MM_FMT_YV12, 0);
#else
	//Ƃ肠YUY2̂
	h = open_mm_srv(file, MM_FMT_YUY2, 0);
#endif

	return (INPUT_HANDLE)h;
}


//---------------------------------------------------------------------
//		t@CN[Y
//---------------------------------------------------------------------
BOOL func_close( INPUT_HANDLE ih )
{
	close_mm_srv((mm_srv_handle *)ih);

	return TRUE;
}


//---------------------------------------------------------------------
//		t@C̏
//---------------------------------------------------------------------
BOOL func_info_get( INPUT_HANDLE ih,INPUT_INFO *iip )
{
	mm_srv_handle *h = (mm_srv_handle *)ih;
	static BITMAPINFOHEADER bmi;

	bmi.biSize = sizeof(BITMAPINFOHEADER);
	bmi.biWidth = h->w;
	bmi.biHeight = h->h;
	bmi.biPlanes = 1;
	bmi.biBitCount = 16;
	bmi.biCompression = '2YUY';
	bmi.biSizeImage = h->h * h->pitch;
	bmi.biXPelsPerMeter = bmi.biYPelsPerMeter = 0;
	bmi.biClrUsed = bmi.biClrImportant = 0;

	ZeroMemory(iip, sizeof(INPUT_INFO));

	iip->flag = INPUT_INFO_FLAG_VIDEO;
	iip->rate = h->rate;
	iip->scale = h->scale;
	iip->n = h->frame;
	iip->format = &bmi;
	iip->format_size = sizeof(bmi);
	iip->handler = '2YUY';

	return TRUE;
}


//---------------------------------------------------------------------
//		摜ǂݍ
//---------------------------------------------------------------------
int func_read_video( INPUT_HANDLE ih,int frame,void *buf )
{
	mm_srv_handle *h = (mm_srv_handle *)ih;
	BYTE *img;
	SIZE_T size = h->h * h->pitch;

	img = (BYTE*)get_frame_mm_srv(h, frame);
	if(NULL == img){
		size = 0;
	}else{
#ifdef YV12_TEST
		yv12_2_yuy2((BYTE*)buf, img, h->w, h->w, h->h);
#else
		CopyMemory(buf, img, size);
#endif
	}

	return (int)size;
}

//---------------------------------------------------------------------
//		ǂݍ
//---------------------------------------------------------------------
int func_read_audio( INPUT_HANDLE ih,int start,int length,void *buf )
{
	return 0;
}

#ifdef YV12_TEST
/*
 * vO YV12 -> YUY2
 * nearest neighbor
 *
 */
static void yv12_2_yuy2(unsigned char *dst, unsigned char *src,
						long width_in, long width_out, long height)
{
	int i,j;
	int h_width = width_in >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp, *src_vtmp;
	unsigned char *src_v = src + offsY;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;
		src_vtmp = src_v + (i>>1) * h_width;
		for(j=0; j<h_width; ++j) {
			//Y0
			*dst_tmp       = *src;
			//U0
			*(dst_tmp + 1) = *(src_vtmp + offsV);
			//Y1
			*(dst_tmp + 2) = *(src + 1);
			//V0
			*(dst_tmp + 3) = *src_vtmp;

			src += 2;
			src_vtmp++;
			dst_tmp += 4;
		}
	}
}
#endif
