//----------------------------------------------------------------------------------
//		Memory Mapped T[o[(o̓vOC)  for AviUtl ver0.98ȍ~
//----------------------------------------------------------------------------------
#include <windows.h>

#include "mms.h"
#include "mms_util.h"
#include "conf_dlg.h"

#include "resource.h"

//---------------------------------------------------------------------
//		o̓vOCϐ
//---------------------------------------------------------------------
MMS_CONFIG config = { BUFF_NUM_DEF, false, true, true, TEXT(""), TEXT("") };
HINSTANCE hdll = NULL;

//---------------------------------------------------------------------
//		o̓vOC\̒`
//---------------------------------------------------------------------
OUTPUT_PLUGIN_TABLE output_plugin_table = {
	NULL,
	"MM Server",
	"AVUFile (*.avu)\0*.avu\0",
	"MM Server version 0.5 By N099",
	NULL,
	NULL,
	func_output,
	func_config,
	func_config_get,
	func_config_set,
};

//---------------------------------------------------------------------
//		DLLGg|Cg
//---------------------------------------------------------------------
BOOL WINAPI DllMain(HINSTANCE hd, DWORD reason, LPVOID)
{
	switch(reason)
	{
		case DLL_PROCESS_ATTACH: //dllCX^XL
			hdll = hd;
			break;
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
	}
	return TRUE;
}

//---------------------------------------------------------------------
//		o̓vOC\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C __declspec(dllexport)
OUTPUT_PLUGIN_TABLE* __stdcall GetOutputPluginTable(void)
{
	return &output_plugin_table;
}

//---------------------------------------------------------------------
//		o̓vOCo͊֐
//---------------------------------------------------------------------
BOOL func_output(OUTPUT_INFO *oip)
{
	MmSrv mms(oip, &config);

	/* L}bv */
	if(!mms.InitMapping(hdll)) return TRUE;

	/* ڑĂ܂ő҂ */
	bool executed = false;
	bool wait_loop = true;

	while(wait_loop){
		if(oip->func_is_abort()) return TRUE;

		/* R}hs */
		if(config.command && (false == executed)){
			executed = true;
			if(false == cmd_exec(oip->savefile)){
				 return TRUE;
			}
		}

		/* ڑ҂ */
		if(mms.WaitConnection()){
			wait_loop = false;
		}
	}

	/** C[v **/
	mms.DoMain();

	return TRUE;
}

//---------------------------------------------------------------------
//		o̓vOCݒ֐
//---------------------------------------------------------------------
BOOL func_config(HWND hwnd, HINSTANCE dll_hinst)
{
	DialogBox(dll_hinst, MAKEINTRESOURCE(IDD_CONFIG),
		hwnd, (DLGPROC)func_config_proc);
	return TRUE;
}

int func_config_get(void *data, int)
{
	if(data) CopyMemory(data, &config, sizeof(config));
	return sizeof(config);
}

int func_config_set(void *data, int size)
{
	if(size != sizeof(config)) return NULL;

	CopyMemory(&config, data, size);
	config.work_dir[MMS_MAX_PATH - 1] = TEXT('\0');
	config.cmd_line[MMS_MAX_CMDLINE - 1] = TEXT('\0');

	return size;
}

